;*********************** >>CPU.ASM<< ************************
;
; Emulated CPU layout
;
; (16 bit registers)
;  r0
;  r1
;  r2
;  r3
;  r4
;  r5
;  r6
;  r7
;

;16bit registers, every register contains two 16bit sides.
r0 .word 0,0
r1 .word 0,0
r2 .word 0,0
r3 .word 0,0
r4 .word 0,0
r5 .word 0,0
r6 .word 0,0
r7 .word 0,0

;
; DOC:
; ----
;
; function( arg1, arg2, arg3, arg4 )
;
; ldx arg1+0
; ldy arg1+1
; stx r0+0
; sty r0+1
;
; ldx arg2+0
; ldy arg2+1
; stx r1+0
; sty r1+1
;
; ldx arg3+0
; ldy arg3+1
; stx r2+0
; sty r2+1
;
; ldx arg4+0
; ldy arg4+1
; stx r3+0
; sty r3+1
;
;
;
;
;

;
;       asmcall( asmfunction rega regx regy );
;
asmcall         lda r1
                ldx r2
                ldy r3
                jmp (r0)

;
;       setregs( rega regx regy );
;
setregs         lda r0
                ldx r1
                ldy r2
                rts
;************************************************************
;
