;
;
;       System Timer Library
;       +Features support for 1000/1003 music.
;
;


timer_init      lda #0
                sta timer_counter1+0
                sta timer_counter1+1
                sta timer_counter2+0
                sta timer_counter2+1
                rts

timer_on        lda #$ff
timer_onl1      cmp $d012
                bne timer_onl1
                sei
                lda #<timer_irq
                ldx #>timer_irq
                sta $0314
                stx $0315
                lda #1
                sta $d01a
                sta $dc0d
                lda $d011
                and #$7f
                sta $d011
                lda #0
                sta $d012
                cli
                rts

timer_irq       lda timer_play1003
                beq timer_np
                jsr playifavailable
timer_np        jsr timer_increase                
                inc $d019
timer_iretadr   jmp $ea7e

timer_increase  nop
                lda timer_counter1+0
                clc
                adc #1
                sta timer_counter1+0
                lda timer_counter1+1
                adc #0
                sta timer_counter1+1
                ;
                lda timer_counter2+0
                clc
                adc #1
                sta timer_counter2+0
                lda timer_counter2+1
                adc #0
                sta timer_counter2+1
                rts

timer_counter1  .word 0
timer_counter2  .word 0

timer_play1003 .byte $ff
